#pragma warning ( disable : 4996 )                                              

#include "stdio.h"
#include "memory.h"

int InsertName(char *, int, char *);
int RemoveName(char*, char*);
void TestInsertName();
void TestRemoveName();

int InsertName(char *pNames, int n, char *pNameToInsert)
{
	if (!pNames || !*pNames)
	{  // checks input data
		return 0; 
	}
	if (!pNameToInsert || !*pNameToInsert)
	{ // checks input data
		return 0; 
	}
	int nNames = 0, nNameToInsert = 0;
	for (int i = 0; i < n; i++)
	{ // calculates the number of characters in initial list
		if (*(pNames + i))
		{
			nNames++;
		}
		else
		{
			break;
		}
	}
	for (int i = 0;   1;   i++)
	{ // calculates the number of characters in the name we have to insert
		if (*(pNameToInsert + i))
		{
			nNameToInsert++;
		}
		else
		{
			break;
		}
	}
	if (nNameToInsert > n - nNames - 2)
	{  // no memory for the new name
	   // we need one byte for terminating zero and one byte for comma after the new name
		return 0;
	}
	memmove(pNames + nNameToInsert + 1, pNames, nNames + 1);
	*(pNames + nNameToInsert) = ',';
	memcpy(pNames, pNameToInsert, nNameToInsert);
	return 1;
}

int RemoveName(char *pNames, char *pNameToRemove)
{
	if (!pNames || !*pNames)
	{  // checks input data
		return 0;
	}
	if (!pNameToRemove || !*pNameToRemove)
	{ // checks input data
		return 0;
	}
	int nNames = 0, nNameToRemove = 0;
	for (int i = 0; 1; i++)
	{ // calculates the number of characters in initial list
		if (*(pNames + i))
		{
			nNames++;
		}
		else
		{
			break;
		}
	}
	for (int i = 0; 1; i++)
	{ // calculates the number of characters in the name we have to remove
		if (*(pNameToRemove + i))
		{
			nNameToRemove++;
		}
		else
		{
			break;
		}
	}
	int i;
	for (i = 0; i < nNames; i++)
	{ // find the index from which the name to remove begins
		if (!memcmp(pNames + i, pNameToRemove, nNameToRemove))
		{
			break;
		}
	}
	if (i == nNames)
	{ // not found
		return 0;
	}
	if (*(pNames + i + nNameToRemove))
	{ // the name to remove is not the last name in list
		memmove(pNames + i, pNames + i + nNameToRemove + 1, nNames - (i + nNameToRemove));
	}
	else
	{ // the name to remove is te last: just put the terminating zero on the place of last comma
		*(pNames + i - 1) = 0;
	}
	return 1;
}

void TestInsertName()
{
	char buf[81], new_name[81];
	printf("Type a list of names separated by comma\n");
	scanf("%s", buf);
	printf("Type the name to insert\n");
	scanf("%s", new_name);
	if (InsertName(buf, sizeof buf, new_name))
	{
		printf("New list: %s\n", buf);
	}
	else
	{
		printf("Failed\n");
	}
}

void TestRemoveName()
{
	char buf[81], name[81];
	printf("Type a list of names separated by comma\n");
	scanf("%s", buf);
	printf("Type the name to remove\n");
	scanf("%s", name);
	if (RemoveName(buf, name))
	{
		printf("New list: %s\n", buf);
	}
	else
	{
		printf("Failed\n");
	}
}

int main()
{
	TestInsertName();
	TestRemoveName();
	return 0;
}
