#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"

char* ReformatName(char*);
char* CreateRandomName(int, int);

char *ReformatName(char *pInput)
{
	if (!pInput || !*pInput)
		return pInput;
	int n = 0;
	for (; *(pInput + n); n++); // find the number of characters in input text
	char *pOutput = (char *)malloc(n + 2);
	int nSpace = 0;
	for (; *(pInput + nSpace) != ' '; nSpace++); // find the index of space between components
	int i = nSpace + 1, j = 0, k = 0;
	for (; *(pInput + i); i++, j++)
		*(pOutput + j) = *(pInput + i); // copy the family name into output
	*(pOutput + j) = ',';
	*(pOutput + j + 1) = ' ';
	j = j + 2;
	for (; *(pInput + k) != ' ';  k++, j++) // copy the first name into output
		*(pOutput + j) = *(pInput + k);
	*(pOutput + j) = 0;
	return pOutput;
}

char *CreateRandomName(int n1, int n2)
{
	if (n1 <= 0 || n2 <= 0)
	{
		return 0;
	}
	const char alphabet[] = "abcdefghijklmnopqrstuvwxyz";
	char *pResult = (char *)malloc(n1 + n2 + 2);
	for (int i = 0; i < n1; i++)
	{
		*(pResult + i) = alphabet[rand() % 26];
	}
	*pResult = toupper(*pResult);
	*(pResult + n1) = ' ';
	for (int i = 0; i < n2; i++)
	{
		*(pResult + n1 + 1 + i) = alphabet[rand() % 26];
	}
	*(pResult + n1 + 1) = toupper(*(pResult + n1 + 1));
	*(pResult + n1 + n2 + 1) = 0;
	return pResult;
}

int main()
{
	for (int i = 0; i < 5; i++)
	{
		char *pIn = CreateRandomName(i, i);
		if (pIn)
			printf("%s\n", pIn);
		char *pOut = ReformatName(pIn);
		if (pOut)
		{
			printf("%s\n", pOut);
			free(pOut);
		}
		if (pIn)
			free(pIn);
	}
	return 0;
}

