#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"

char** SentenceSplit(char *, int *);
char* CreateRandomSentence(int, int, ...);

char **SentenceSplit(char *pInput, int *pnWords)
{
	if (!pInput || !*pInput)
		return 0;
	int nSpace = 0;
	for (int i = 0; *(pInput + i); i++)
	{
		if (*(pInput + i) == ' ')
			nSpace++;
	}
	*pnWords = nSpace + 1;
	char **ppOutput = (char **)malloc(*pnWords * sizeof(char *));
	for (int i = 0, iWordBegin = 0; i < *pnWords; i++)
	{
		int nWord = 0;
		for (int j = iWordBegin; *(pInput + j) && *(pInput + j) != ' '; j++, nWord++);
		*(ppOutput + i) = (char *)malloc(nWord + 1);
		for (int j = 0;  j < nWord; j++)
		{
			*(*(ppOutput + i) + j) = *(pInput + iWordBegin + j);
		}
		*(*(ppOutput + i) + nWord) = 0;
		iWordBegin += nWord + 1;
	}
	return ppOutput;
}

char *CreateRandomSentence(int nWords, int n1, ...)
{
	va_list indic;
	va_start(indic, nWords);
	int nChars = 0, j = 0;
	for (int i = 0; i < nWords; i++, nChars += va_arg(indic, int) + 1);
	const char alphabet[] = "abcdefghijklmnopqrstuvwxyz";
	if (!nWords)
		nChars = 1;
	char *pResult = (char *)malloc(nChars);
	va_start(indic, nWords);
	for (int i = 0; i < nWords; i++)
	{
		int nWord = va_arg(indic, int);
		for (int k = 0; k < nWord; k++, *(pResult + j++) = alphabet[rand() % 26]);
		*(pResult + j++) = ' ';
	}
	*(pResult + nChars - 1) = 0;
	return pResult;
}

int main()
{
	char *pSentence = 0;
	for (int i = 0; i < 6; i++)
	{
		switch (i)
		{
		case 0:
			pSentence = CreateRandomSentence(1, 10);
			break;
		case 1:
			pSentence = CreateRandomSentence(6, 4, 2, 1, 4, 4, 3);
			break;
		case 2:
			pSentence = CreateRandomSentence(3, 1, 10, 1);
			break;
		case 3:
			pSentence = CreateRandomSentence(3, 4, 4, 4);
			break;
		case 4:
			pSentence = CreateRandomSentence(0, 0);
			break;
		case 5:
			pSentence = 0;
			break;
		}
		int nw;
		char **ppTable = SentenceSplit(pSentence, &nw);
		for (int i = 0; ppTable && i < nw; i++)
		{
			printf("%s\n", *(ppTable + i));
			free(*(ppTable + i));
		}
		if (ppTable)
			free(ppTable);
		if (pSentence)
		{
			printf("%s\n\n", pSentence);
			free(pSentence);
		}
	}
	return 0;
}