#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "ctype.h"

int CharFreq(char*, char);

int *CharFreqs(char *pInput)
{
	if (!pInput || !*pInput)
		return 0;
	int n = strlen(pInput);
	for (int i = 0; i < n; i++)
	{
		*(pInput + i) = tolower(*(pInput + i));
	}
	int *pFreqs = (int *)calloc(26, sizeof(int));
	for (int c = 'a', i = 0; c <= 'z'; c++, i++)
	{
		*(pFreqs + i) = CharFreq(pInput, c);
	}
	return pFreqs;
}

int CharFreq(char *pInput, char c)
{
	if (!pInput || !*pInput)
		return 0; // errors in input
	int nChar = 0;
	for (char *p = pInput; 1; )
	{
		char *q = strchr(p, c); // pointer to found character
		if (!q)
			break;
		else
		{
			nChar++;
			p = q + 1; // follow se<arching from the position following the found character
		}
	}
	return nChar;
}

int main()
{
	char buf[] = "abcdefghijklmnopqrstuvwxyz";
	int *pResult = CharFreqs(buf);
	for (int i = 0; i < 26; i++)
		printf("%c - %d\n", 'a' + i, *(pResult + i));
	free(pResult);
	return 0;
}