#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdarg.h"

char *CreateRandomSentence(int nWords, int n1, ...);
char **SentenceSplit_1(char *pInput, int *pnWords);
char **SentenceSplit_2(char *pInput, int *pnWords);

char *CreateRandomSentence(int nWords, int n1, ...)
{ // this code is out of scope of this course. 
   // #include "stdarg.h" is needed
   // nWords is the number of words, it is followed by sequence specifying the word lengths
   // nWords may be any positive number
  va_list indic;
  va_start(indic, nWords);
  int nChars = 0, j = 0;
  for (int i = 0; i < nWords; i++, nChars += va_arg(indic, int) + 1);
  const char alphabet[] = "abcdefghijklmnopqrstuvwxyz";
  char *pResult = (char *)malloc(nChars);
  va_start(indic, nWords);
  for (int i = 0; i < nWords; i++)
  {
        int nWord = va_arg(indic, int);
        for (int k = 0; k < nWord; k++, *(pResult + j++) = alphabet[rand() % 26]);
        *(pResult + j++) = ' ';
  }
  *(pResult + nChars - 1) = 0;
  return pResult;
}

char **SentenceSplit_1(char *pInput, int *pnWords)
{
	if (!pInput || !*pInput)
		return 0;
	int nInput = strlen(pInput);
	int nSpace = 0;
	for (char *p = pInput; 1; )
	{
		char *q = strchr(p, ' ');
		if (!q)
			break;
		else
		{
			nSpace++; // count the number of spaces
			*q = 0; // replace space with zero
			p = q + 1;
		}
	}
	*pnWords = nSpace + 1;
	char **ppOutput = (char **)malloc(*pnWords * sizeof(char *));
	for (int i = 0, iWordBegin = 0;  i < *pnWords;  i++)
	{
		int nWord = strlen(pInput + iWordBegin); // length of word
		*(ppOutput + i) = (char *)malloc(nWord + 1); // memory for word in table
		strcpy(*(ppOutput + i), pInput + iWordBegin); // sopy the word into table
		*(pInput + iWordBegin + nWord) = ' '; // write the space back into input data
		iWordBegin += nWord + 1; // position of the first character of the next word
	}
	*(pInput + nInput) = 0;
	return ppOutput;
}

char** SentenceSplit_2(char* pInput, int* pnWords)
{
	if (!pInput || !*pInput)
	{
		return 0;
	}
	int nSpace = 0;
	for (char* p = pInput; 1; p++)
	{
		if (!(p = strchr(p, ' ')))
		{
			break;
		}
		else
		{
			nSpace++; // count the number of spaces
		}
	}
	*pnWords = nSpace + 1;
	char** ppOutput = (char**)malloc(*pnWords * sizeof(char*));
	int i = 0;
	for (char *pToken = strtok(pInput, " ");  1;  i++)
	{
		*(ppOutput + i) = (char*)malloc(strlen(pToken) + 1);
		strcpy(*(ppOutput + i), pToken);
		pToken = strtok(0, " ");
		if (!pToken)
		{
			break;
		}
	}
	return ppOutput;
}

int main()
{
	char* pSentence1 = 0, * pSentence2 = 0;;
	for (int i = 0; i < 6; i++)
	{
		switch (i)
		{
		case 0:
			pSentence1 = CreateRandomSentence(1, 10);
			pSentence2 = CreateRandomSentence(1, 10);
			break;
		case 1:
			pSentence1 = CreateRandomSentence(6, 4, 2, 1, 4, 4, 3);
			pSentence2 = CreateRandomSentence(6, 4, 2, 1, 4, 4, 3);
			break;
		case 2:
			pSentence1 = CreateRandomSentence(3, 1, 10, 1);
			pSentence2 = CreateRandomSentence(3, 1, 10, 1);
			break;
		case 3:
			pSentence1 = CreateRandomSentence(3, 4, 4, 4);
			pSentence2 = CreateRandomSentence(3, 4, 4, 4);
			break;
		case 4:
			pSentence1 = CreateRandomSentence(0, 0);
			pSentence2 = CreateRandomSentence(0, 0);
			break;
		case 5:
			pSentence1 = pSentence2 = 0;
			break;
		}
		int nw;
		if (pSentence1)
		{
			printf("\n\n\nOriginal: %s (%d)\nSplit:\n", pSentence1, i);
		}
		char **ppTable = SentenceSplit_1(pSentence1, &nw);
		for (int i = 0; ppTable && i < nw; i++)
		{
			printf("%s\n", *(ppTable + i));
			free(*(ppTable + i));
		}
		if (ppTable)
		{
			free(ppTable);
		}
		
		if (pSentence2)
		{
			printf("\n\n\nOriginal:%s (%d)\nSplit:\n", pSentence2, i);
		}
		ppTable = SentenceSplit_2(pSentence2, &nw);
		for (int i = 0; ppTable && i < nw; i++)
		{
			printf("%s\n", *(ppTable + i));
			free(*(ppTable + i));
		}
		if (ppTable)
		{
			free(ppTable);
		}

		if (pSentence1)
		{
			free(pSentence1);
		}
		if (pSentence2)
		{
			free(pSentence2);
		}
	}
	return 0;
}